|
% H _5 j2 C# z" C! a ; i( n* o# ^3 @# u 前言 递归是一种非常重要的算法思想,无论你是前端开发,还是后端开发,都需要掌握它。在日常工作中,统计文件夹大小,解析xml文件等等,都需要用到递归算法。它太基础太重要了,这也是为什么面试的时候,面试官经常让我们手写递归算法。本文呢,将跟大家一起学习递归算法~
递归,在计算机科学中是指一种通过重复将问题分解为同类的子问题而解决问题的方法。简单来说,递归表现为函数调用函数本身。在知乎看到一个比喻递归的例子,个人觉得非常形象,大家看一下: ❝ 来试试水,看一个递归的代码例子吧,如下: public int sum(int n) {if (n <= 1) {5 g- {$ I% g- ~( Z return 1;4 n' i- b. b0 S( s2 W) ~2 c } return sum(n - 1) + n; } 递归的特点 实际上,递归有两个显著的特征,终止条件和自身调用:
结合以上demo代码例子,看下递归的特点:
其实,递归的过程,可以理解为出入栈的过程的,这个比喻呢,只是为了方便读者朋友更好理解递归哈。以上代码例子计算sum(n=3)的出入栈图如下:
为了更容易理解一些,我们来看一下 函数sum(n=5)的递归执行过程,如下:
哪些问题我们可以考虑使用递归来解决呢?即递归的应用场景一般有哪些呢?
解决递归问题一般就三步曲,分别是:
这个递归解题三板斧理解起来有点抽象,我们拿阶乘递归例子来喵喵吧~ 1.定义函数功能定义函数功能,就是说,你这个函数是干嘛的,做什么事情,换句话说,你要知道递归原问题是什么呀?比如你需要解决阶乘问题,定义的函数功能就是n的阶乘,如下: //n的阶乘(n为大于0的自然数)int factorial (int n){4 z5 {4 p+ F8 a8 p* z % }$ r; S6 V+ X3 | }" ?, u9 H0 |) _" W5 L 2.寻找递归终止条件 递归的一个典型特征就是必须有一个终止的条件,即不能无限循环地调用本身。所以,用递归思路去解决问题的时候,就需要寻找递归终止条件是什么。比如阶乘问题,当n=1的时候,不用再往下递归了,可以跳出循环啦,n=1就可以作为递归的终止条件,如下: //n的阶乘(n为大于0的自然数)int factorial (int n){1 }& |& E( P% \* G9 M' Y, ^ if(n==1){: `$ S/ C4 R$ ?) P2 z/ ] return 1; } }6 M) Y k% J6 F+ G# [& k& d+ _4 O 3.递推函数的等价关系式 递归的「本义」,就是原问题可以拆为同类且更容易解决的子问题,即「原问题和子问题都可以用同一个函数关系表示。递推函数的等价关系式,这个步骤就等价于寻找原问题与子问题的关系,如何用一个公式把这个函数表达清楚」。阶乘的公式就可以表示为 f(n) = n * f(n-1), 因此,阶乘的递归程序代码就可以写成这样,如下: int factorial (int n){if(n==1){ return 1; }- j# B) `" Q# v return n * factorial(n-1); }. g1 c. I# j e5 c% [% p" C( R 「注意啦」,不是所有递推函数的等价关系都像阶乘这么简单,一下子就能推导出来。需要我们多接触,多积累,多思考,多练习递归题目滴~ leetcode案例分析来分析一道leetcode递归的经典题目吧~ ❝ 「题目:」 翻转一棵二叉树。 输入: 4! E$ V- `" i( p2 c4 p/ \ 2 79 N: j" H3 R# h5 D/ B- _+ N' j: L / \ / \9 N6 H% |" m2 v9 w( @- q# H 1 3 6 95 b- ^! o2 J6 T# E; b7 Y 输出: 4( N8 R, g, a0 R. C/ h/ \! o/ X: J9 O& J4 z6 g4 U 7 2 / \ / \4 x& J, A7 K" p! C' F5 h3 e 9 6 3 1! ]! g# V$ g4 {+ ~; {8 L8 p 我们按照以上递归解题的三板斧来: 「1. 定义函数功能」 函数功能(即这个递归原问题是),给出一颗树,然后翻转它,所以,函数可以定义为: //翻转一颗二叉树1 V& t2 f% y, U6 T7 ^2 bpublic TreeNode invertTree(TreeNode root) {4 |% J, Y5 L3 K# l" [0 l+ P7 i1 o }5 b( D/ S, V4 l8 v" D /**2 J% k: x4 D1 @+ l4 Y6 d2 M * Definition for a binary tree node.6 ? ^% T: w2 E! l# Z * public class TreeNode {% c, _( L; x" a7 Q6 x * int val; * TreeNode left; * TreeNode right; * TreeNode(int x) { val = x; }; f( n7 y( L+ O8 h; F * }7 v; Q! @; ^5 V3 G' e */- W' v$ C7 @4 w) M" p) x$ E) X4 I 「2.寻找递归终止条件」 这棵树什么时候不用翻转呢?当然是当前节点为null或者当前节点为叶子节点的时候啦。因此,加上终止条件就是: //翻转一颗二叉树* f8 x9 {5 _# |, k/ ^7 \. m H' bpublic TreeNode invertTree(TreeNode root) {3 T( T1 l k* @$ k* S/ I if(root==null || (root.left ==null && root.right ==null)){ r, u) C6 E" Y2 @5 G1 u return root; |9 z6 `, O) r/ ?& v6 J0 z8 z7 L4 k } }$ L- K, z# @1 U! M( j 「3. 递推函数的等价关系式」 原问题之你要翻转一颗树,是不是可以拆分为子问题,分别翻转它的左子树和右子树?子问题之翻转它的左子树,是不是又可以拆分为,翻转它左子树的左子树以及它左子树的右子树?然后一直翻转到叶子节点为止。嗯,看图理解一下咯~
首先,你要翻转根节点为4的树,就需要「翻转它的左子树(根节点为2)和右子树(根节点为7)」。这就是递归的「递」的过程啦
然后呢,根节点为2的树,不是叶子节点,你需要继续「翻转它的左子树(根节点为1)和右子树(根节点为3)」。因为节点1和3都是「叶子节点」了,所以就返回啦。这也是递归的「递」的过程~
同理,根节点为7的树,也不是叶子节点,你需要翻转「它的左子树(根节点为6)和右子树(根节点为9)」。因为节点6和9都是叶子节点了,所以也返回啦。
左子树(根节点为2)和右子树(根节点为7)都被翻转完后,这几个步骤就「归来」,即递归的归过程,翻转树的任务就完成了~
显然,「递推关系式」就是: invertTree(root)= invertTree(root.left) + invertTree(root.right);: L* I; `: M3 m8 J8 A" }4 K& `+ d0 O于是,很容易可以得出以下代码: //翻转一颗二叉树public TreeNode invertTree(TreeNode root) { if(root==null || (root.left ==null && root.right ==null){ return root;7 N d4 {- G2 ?; r) t } //翻转左子树* @1 y0 \+ c {. J7 I5 [ TreeNode left = invertTree(root.left);3 F# {' G( W# X6 r6 O4 [; s/ U //翻转右子树 TreeNode right= invertTree(root.right); }) z4 a8 v) c) S- g; ` 这里代码有个地方需要注意,翻转完一棵树的左右子树,还要交换它左右子树的引用位置。 root.left = right;% B5 M' g2 S$ d8 L! }root.right = left; 因此,leetcode这个递归经典题目的「终极解决代码」如下: class Solution {public TreeNode invertTree(TreeNode root) {1 q0 l; j& m6 q! f V9 K: @ if(root==null || (root.left ==null && root.right ==null)){5 }9 s% i; _8 C0 w; A return root;$ y% u, e! g; a$ N$ }+ M4 S9 S }2 [: d O' j* F' b //翻转左子树 TreeNode left = invertTree(root.left); //翻转右子树 TreeNode right= invertTree(root.right); //左右子树交换位置~+ p* f2 z/ x2 D+ [) C; p1 V# R root.left = right;5 f1 p7 i) q( @4 v root.right = left;/ H. Q3 I7 S- s! t$ @# F3 i/ h return root; }) _2 C% f N2 z# p }+ ~1 I# }- P% [2 j* O 拿终极解决代码去leetcode提交一下,通过啦~
「代码例子如下:」 /*** 递归栈溢出测试 */. `' l q6 ?: b2 o# [ public class RecursionTest { ! ~$ B/ K; Y: e- x' p! u- H F public static void main(String[] args) {3 p$ |, G' {# n sum(50000);7 x* _* t3 g( Y' I1 ] }/ t, w4 a8 [ e! A# e; j/ ]# [! g private static int sum(int n) { if (n <= 1) { return 1; }7 W' P8 X+ ?* p5 Z W! _ return sum(n - 1) + n; } } 「运行结果:」 Exception in thread "main" java.lang.StackOverflowErrorat recursion.RecursionTest.sum(RecursionTest.java:13) 怎么解决这个栈溢出问题?首先需要「优化一下你的递归」,真的需要递归调用这么多次嘛?如果真的需要,先稍微「调大JVM的栈空间内存」,如果还是不行,那就需要弃用递归,「优化为其他方案」咯~ 重复计算,导致程序效率低下我们再来看一道经典的青蛙跳阶问题:一只青蛙一次可以跳上1级台阶,也可以跳上2级台阶。求该青蛙跳上一个 n 级的台阶总共有多少种跳法。 绝大多数读者朋友,很容易就想到以下递归代码去解决: class Solution {public int numWays(int n) { if (n == 0){ return 1; }/ j' N( c. A( R8 ^9 l if(n <= 2){ return n;1 B" F' t+ V. ^" R7 g } return numWays(n-1) + numWays(n-2); }# X9 a2 U4 G! J& T } 但是呢,去leetcode提交一下,就有问题啦,超出时间限制了
为什么超时了呢?递归耗时在哪里呢?先画出「递归树」看看:
我们先来看看这个递归的时间复杂度吧,「递归时间复杂度 = 解决一个子问题时间*子问题个数」
因此,青蛙跳阶,递归解法的时间复杂度 = O(1) * O(2^n) = O(2^n),就是指数级别的,爆炸增长的,「如果n比较大的话,超时很正常的了」。 回过头来,你仔细观察这颗递归树,你会发现存在「大量重复计算」,比如f(8)被计算了两次,f(7)被重复计算了3次...所以这个递归算法低效的原因,就是存在大量的重复计算! 「那么,怎么解决这个问题呢?」 既然存在大量重复计算,那么我们可以先把计算好的答案存下来,即造一个备忘录,等到下次需要的话,先去「备忘录」查一下,如果有,就直接取就好了,备忘录没有才再计算,那就可以省去重新重复计算的耗时啦!这就是「带备忘录的解法」 我们来看一下「带备忘录的递归解法」吧~ 一般使用一个数组或者一个哈希map充当这个「备忘录」。 假设f(10)求解加上「备忘录」,我们再来画一下递归树: 「第一步」,f(10)= f(9) + f(8),f(9) 和f(8)都需要计算出来,然后再加到备忘录中,如下:
「第二步,」 f(9) = f(8)+ f(7),f(8)= f(7)+ f(6), 因为 f(8) 已经在备忘录中啦,所以可以省掉,f(7),f(6)都需要计算出来,加到备忘录中~
「第三步,」 f(8) = f(7)+ f(6),发现f(8),f(7),f(6)全部都在备忘录上了,所以都可以剪掉。
所以呢,用了备忘录递归算法,递归树变成光秃秃的树干咯,如下:
带「备忘录」的递归算法,子问题个数=树节点数=n,解决一个子问题还是O(1),所以「带「备忘录」的递归算法的时间复杂度是O(n)」。接下来呢,我们用带「备忘录」的递归算法去撸代码,解决这个青蛙跳阶问题的超时问题咯~,代码如下: public class Solution {& w6 B& y5 |: S+ r//使用哈希map,充当备忘录的作用( d) C& a2 \6 |' S; t. L Map<Integer, Integer> tempMap = new HashMap();6 b& g O2 Z" g/ M. j8 w public int numWays(int n) { // n = 0 也算1种 if (n == 0) { |6 `3 t" v; y# l7 g2 Q7 {0 V return 1; }6 ^8 M5 b) P P* ` if (n <= 2) {6 K4 A; e2 w/ G" t+ G' X return n; }% C9 t1 q& x& C( `, ]$ w //先判断有没计算过,即看看备忘录有没有1 j1 Y- D; j+ K; L U5 }2 Y9 h2 n) P5 n if (tempMap.containsKey(n)) {# E( q# u& B4 D& @8 H& o //备忘录有,即计算过,直接返回 return tempMap.get(n); } else { // 备忘录没有,即没有计算过,执行递归计算,并且把结果保存到备忘录map中,对1000000007取余(这个是leetcode题目规定的) tempMap.put(n, (numWays(n - 1) + numWays(n - 2)) % 1000000007);3 G r( g1 Y) |2 q return tempMap.get(n); } } }- {1 X" s* e, }" y9 p 去leetcode提交一下,如图,稳了:
还有没有其他方案解决这个问题呢?只有「带备忘录的递归解法」?其实吧,还可以用「动态规划」去解决 动态规划算法思想怎么解题呢?我们下期继续~ 谢谢阅读~ |
微信公众号
手机版